import type { Result } from "@stacksjs/error-handling";
import type { CliOptions, Readable, Subprocess, Writable } from "@stacksjs/types";
type CommandOptionTuple = [string, string, { default: boolean }];
interface CommandOptionObject {
	name: string;
	description: string;
	default: boolean | string;
}
type CommandOptions = CommandOptionTuple | CommandOptionObject[];
interface Options {
	name: string;
	description: string;
	active: boolean;
	options: CommandOptions;
	run: (options?: CliOptions) => Promise<any>;
	onFail: (error: Error) => void;
	onSuccess: () => void;
}
export declare class Command {
	name: Options["name"];
	description: Options["description"];
	options: Options["options"];
	run: Options["run"];
	onFail: Options["onFail"];
	onSuccess: Options["onSuccess"];
	constructor({ name, description, options, run, onFail, onSuccess }: Options);
}
export declare const command: {
	run: (command: string, options?: CliOptions) => Promise<Result<Subprocess<Writable, Readable, Readable>, Error>>;
	runSync: (command: string, options?: CliOptions) => Promise<Result<Subprocess<Writable, Readable, Readable>, Error>>;
};
export {};
